
#include <avr/io.h>

// INLINE Problem / Bug
//
// First compile this code with the makefile included in the archive.
// You'll see that it gives 234 Bytes with WinAVR 20070122.
// Optimisation level is -Os
//
// Now outcomment this: 
// void putch(char ch) __attribute__((noinline));

// You'll get 216 Bytes! (2 Bytes less for each call from the main function!)
// If you make the putch function just a little bit larger, it works like
// intended and it does not get inlined anymore! 
// Seems to affect only small functions... 

void putch(char ch)
{
  while (!(UCSRA & (1<<UDRE)));
  UDR = ch;
}

int main(void)
{
  putch(0); 
  putch(1); 
  putch(2); 
  putch(3);
  putch(4); 
  putch(5); 
  putch(6);
  putch(7);
  putch(8);
  putch(9);
  
  return 0;
}
